<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.parkinglot_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/parkinglot";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "索引ID",
              prop: "indexId",
              rules: [{
                required: true,
                message: "请输入索引ID",
                trigger: "blur"
              }]
            },
            {
              label: "车场唯一编号",
              prop: "parkKey",
              rules: [{
                required: true,
                message: "请输入车场唯一编号",
                trigger: "blur"
              }]
            },
            {
              label: "所属社区",
              prop: "agencyId",
              rules: [{
                required: true,
                message: "请输入所属社区",
                trigger: "blur"
              }]
            },
            {
              label: "所属小区",
              prop: "residentialId",
              rules: [{
                required: true,
                message: "请输入所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "停车场名称",
              prop: "parkName",
              rules: [{
                required: true,
                message: "请输入停车场名称",
                trigger: "blur"
              }]
            },
            {
              label: "车场纬度",
              prop: "parkLatitude",
              rules: [{
                required: true,
                message: "请输入车场纬度",
                trigger: "blur"
              }]
            },
            {
              label: "车场经度",
              prop: "parkLongitude",
              rules: [{
                required: true,
                message: "请输入车场经度",
                trigger: "blur"
              }]
            },
            {
              label: "车场地址",
              prop: "parkAdd",
              rules: [{
                required: true,
                message: "请输入车场地址",
                trigger: "blur"
              }]
            },
            {
              label: "车场联系方式",
              prop: "parkTel",
              rules: [{
                required: true,
                message: "请输入车场联系方式",
                trigger: "blur"
              }]
            },
            {
              label: "车场联系人",
              prop: "parkLinkman",
              rules: [{
                required: true,
                message: "请输入车场联系人",
                trigger: "blur"
              }]
            },
            {
              label: "免费分钟数	",
              prop: "parkFreeTime",
              rules: [{
                required: true,
                message: "请输入免费分钟数	",
                trigger: "blur"
              }]
            },
            {
              label: "免费超时分钟数	",
              prop: "parkFreeTimeout",
              rules: [{
                required: true,
                message: "请输入免费超时分钟数	",
                trigger: "blur"
              }]
            },
            {
              label: "车场收费说明	",
              prop: "chargesDesc",
              rules: [{
                required: true,
                message: "请输入车场收费说明	",
                trigger: "blur"
              }]
            },
            {
              label: "停车场是否启用预定功能",
              prop: "reserveStatus",
              rules: [{
                required: true,
                message: "请输入停车场是否启用预定功能",
                trigger: "blur"
              }]
            },
            {
              label: "注册时间	",
              prop: "regTime",
              rules: [{
                required: true,
                message: "请输入注册时间	",
                trigger: "blur"
              }]
            },
            {
              label: "停车场有效期止日	",
              prop: "validTime",
              rules: [{
                required: true,
                message: "请输入停车场有效期止日	",
                trigger: "blur"
              }]
            },
            {
              label: "停车场可容纳的车位总数",
              prop: "spaceTotal",
              rules: [{
                required: true,
                message: "请输入停车场可容纳的车位总数",
                trigger: "blur"
              }]
            },
            {
              label: "车牌地区简称	",
              prop: "cityShortName",
              rules: [{
                required: true,
                message: "请输入车牌地区简称	",
                trigger: "blur"
              }]
            },
            {
              label: "空余车位",
              prop: "remainSpace",
              rules: [{
                required: true,
                message: "请输入空余车位",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.parkinglot_add, false),
          viewBtn: this.vaildData(this.permission.parkinglot_view, false),
          delBtn: this.vaildData(this.permission.parkinglot_delete, false),
          editBtn: this.vaildData(this.permission.parkinglot_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
